#
#  Script for otv4vdr plugin.
#
#  It records the EPG within VDR.
#
#  You may update it in case of new release of 'load-otc-epg.py' script
#  Source: http://vdr.bluox.org/download/EPG/otvepg.zip
# 
# $1 -> VDR Config directory
# $2 -> Int 'EPG Updated' message
#

PATH=/usr/local/src/VDR:$PATH
CONF=../../channels.conf
ALIAS=./channels

cd "$1/otv4vdr"

awk -v conf=$CONF -v alias=$ALIAS '
BEGIN{found=0;undef=""}
/^C / {
       split($0,array,/^C [0-9]* */)
       print "C"
       val=system("grep \"^"array[2]"[:;]\" "conf)
       found=1
       epg=""
       if(val) {
               val=system ("grep -q \"^"array[2]":\" "alias)
               if (val) {
                        print "C NOT FOUND"
                        undef=undef array[2]"\n"
                        found=0;
                        } else {
                        system ("grep \"^`grep \"^"array[2]"\" "alias" | cut -d: -f2`[:;]\" "conf)
                        }
               }
       next;
       }
/^c$/{if (found == 0) next
    found=0;
    print "c"

    next}
/^E$/ {if (found == 0) next
      epg=$0 "\n"
      next}
/^e$/ {if (found == 0) next
      print epg $0
      next}
//{if (found == 0) next
   epg=epg $0"\n"}
END{system("echo \""undef"\" > /tmp/undef.channels")}
' epg.dat | awk '
BEGIN{process=0;nbentry=0;X=0;T=1;D=2;L=3;S=4
          event_id=3453
          event_list_nb=0
}
/^C NOT FOUND/{process=0;nbentry=0;next}
/^C$/{process=1;event_list_nb=-1;next}
/^c$/ { if (nbentry==0) next;
           for (i=0;i<nbentry;i++) {
              print tbentry[i+1]
           for (j=0;j<=event_list_nb;j++)
              print event_list[j]
           }
           print "c"
       next
       }
/^E$/ {if ( process > 0 ) {
           nbentry=process-1;process=0
            }
       if (nbentry==0) next;
       epg=nbentry;
       tabevent[X]=""
       tabevent[T]="T aucun"
       tabevent[D]="D aucune"
       tabevent[L]="L 0"
       tabevent[S]="S aucun"
       next
      }
/^X / {if (nbentry==0) next
      tabevent[X]=$0;
      next
      }
/^T / {if (nbentry==0) next
      tabevent[T]=$0;
      next
      }
/^D / {if (nbentry==0) next
      tabevent[D]=$0;
      next
      }
/^L / {if (nbentry==0) next
      tabevent[L]=$0;
      next
      }
/^S / {if (nbentry==0) next
      tabevent[S]=$0;
      next
      }
/^e$/ {if (nbentry==0) next
      while (event_ids[event_id]==1) {event_id++}
      event_ids[event_id]=1
      split(tabevent[X],xline,/ /)
      split(tabevent[L],lline,/ /)
      event_list_nb++
      event_list[event_list_nb]="E "event_id" "xline[2]" "(lline[2]*60)" 0 \n"tabevent[T]"\n"tabevent[S]"\n"tabevent[D]"\ne"
      next
     }
//{if (process > 0) {
          split($0,vdrentry,/:/)
          split(vdrentry[1],vdrname,/;/)
          tbentry[process]="C "vdrentry[4]"-"vdrentry[11]"-"vdrentry[12]"-"vdrentry[10]"-"vdrentry[13]" "vdrname[1]
          process++
        }
}
' > vdr.data.epg

echo pute > head.txt
echo -e ".\nquit\n" > tail.txt
cat head.txt vdr.data.epg tail.txt  | netcat 127.0.0.1 2001
svdrpsend.pl -d 127.0.0.1 MESG "$2";
rm -f epg.dat vdr.data.epg epg.log head.txt tail.txt
